#include<stdio.h>
#include<string.h>
#include<malloc.h>
#include<map>
#include<vector>
#include<stack>
#include<list>

// ===== 

#define FILENAME_STATUS	"status.txt"
#define FILENAME_TABLE	"table.txt"

#define uint unsigned int

#define FLAG_R		128	//  
#define FLAG_ACC	127	//  

// =====   

#define GR_COUNT 6
char *gr[]={"EE+T","ET","TT*F","TF","F(E)","Fi"};
char test_line[]="i+i*i";


//#define GR_COUNT 3
//char *gr[]={"SCC","CaC","Cb"};
//char test_line[]="bb";

//#define GR_COUNT 5
//char *gr[]={"EE+T","ET","TT*F","TF","Fi"};


//#define GR_COUNT 5
//char *gr[]={"SL=R","SR","L*R","Li","RL"};

//#define GR_COUNT 6
//char *gr[]={"SaAd","SbBd","SaBe","SbAe","Ac","Bc"};

//#define GR_COUNT 4
//char *gr[]={"EE+E","EE*E","E(E)","Ei"};

//#define GR_COUNT 3
//char *gr[]={"SiSeS","SiS","Sa"};

//#define GR_COUNT 4
//char *gr[]={"EEsEsE","EEsE","E(E)","c"};

// =====    ( )

class CharSet {
	char *set; 
public:
	CharSet();
	~CharSet();
	void Copy(CharSet*);	//    
	bool Intersect(char*); 	//   
	bool Add(char);		//  
	bool isIn(char);	//    
	char *Get();		//   
	char Get(uint);		//    
	uint GetSize();		//   
	uint GetHash();		//   
};

CharSet::CharSet()
{
	set=(char*)malloc(1); set[0]=0;
}

CharSet::~CharSet()
{
	free(set);
}


void CharSet::Copy(CharSet *obj)
{
	free(set); set=strdup(obj->set);
}

bool CharSet::Intersect(char *add)
{
	int n,m; char sym;
	char *buff=(char*)alloca(strlen(set)+1);
	for(n=m=0; add[n]; n++) if(!strchr(set,add[n])) buff[m++]=add[n];
	if(!m) return false; buff[m++]=0;
	set=(char*)realloc(set,m+strlen(set));
	strcat(set,buff);
	for(n=0; set[n]; n++) for(m=n+1; set[m]; m++) if(set[n]>set[m]) sym=set[n],set[n]=set[m],set[m]=sym;
	return true;
}

bool CharSet::Add(char sym)
{
	char buff[2]; buff[0]=sym; buff[1]=0;
	return Intersect(buff);
}

bool CharSet::isIn(char sym)
{
	return strchr(set,sym)!=0;
}


char CharSet::Get(uint index)
{
	if(index>=strlen(set)) return 0;
	return set[index];
}

char *CharSet::Get()
{
	return set;
}


uint CharSet::GetSize()
{
	return strlen(set);
}

uint CharSet::GetHash()
{
	uint hash=strlen(set); uint n;
	for(n=0; n<(int)strlen(set); n++) hash+=set[n];
	return hash;
}


// ======    

CharSet charset,t_charset;	//   ,   
CharSet *first_set; // first 

//  first   
char *GetSet(char sym)
{
	for(uint n=0; n<charset.GetSize(); n++) if(charset.Get()[n]==sym) return first_set[n].Get();
	return "?";
}

//    frist   
bool AddSet(char sym,char *set)
{
	for(uint n=0; n<charset.GetSize(); n++) if(charset.Get(n)==sym) return first_set[n].Intersect(set);
	return false;
}

//    frist   
bool AddSet(char sym,char add)
{
	char buff[2]; buff[0]=add; buff[1]=0;
	return AddSet(sym,buff);
}

//   
void InstallSets()
{
//  
	uint line,pos,n; bool next;
	for(line=0; line<GR_COUNT; line++) charset.Add(gr[line][0]);
	for(line=0; line<GR_COUNT; line++) for(pos=1; pos<strlen(gr[line]); pos++) if(!charset.isIn(gr[line][pos])) t_charset.Add(gr[line][pos]);
	t_charset.Add('$'); charset.Intersect(t_charset.Get());
	printf("charset: [%s]\n",charset.Get());
	printf("t_charset: [%s]\n",t_charset.Get());
//  frist 
	first_set=new CharSet[charset.GetSize()];
	for(n=0; n<charset.GetSize(); n++) AddSet(t_charset.Get()[n],t_charset.Get(n));
	do { next=false;
		for(line=0; line<GR_COUNT; line++) next=AddSet(gr[line][0],GetSet(gr[line][1]))||next;
	} while(next);
	printf("[first chars]\n");
	for(n=0; n<charset.GetSize(); n++) printf("%c: %s\n",charset.Get()[n],first_set[n].Get());
	printf("\n");
}

// =====     

class Item{
public:
	int line; int pos; CharSet set;
	Item();
	Item(const Item&);
	Item(int,int,char*);
	bool Compare(Item*); //  
};

Item::Item()
{}

Item::Item(const Item&obj)
{
	line=obj.line; pos=obj.pos; set.Copy((CharSet*)&obj.set);
}

Item::Item(int line_,int pos_,char* set_)
{
	line=line_; pos=pos_; set.Intersect(set_);
}

bool Item::Compare(Item *obj)
{
	return line==obj->line && pos==obj->pos && !strcmp(set.Get(),obj->set.Get());
}


// =====    
class Status{
	char info[16];	//          ( )
	uint hash;		//     
	uint hash_kr;	//      
	std::vector<Item>array;	//  
	bool Add(int,int,char*); //  
	void Complement();	 //   (  + )
public:
	int m_id;	//
	Status();
	Status(const Status&);	
	~Status();
	void Start();		//   
	void SetId(int);
	void Dump(FILE*);	// 
	void Copy(Status*);	//  
	bool Compare(Status*);	// 
	bool CompareKernel(Status*); //  
	bool Merge(Status*);	//  
	bool Step(char sym);	//    
	int GetSize();		//     
	Item *GetItem(int);	//   
	void CalcHash();
};

Status::Status()
{
	info[0]=0;
}

Status::Status(const Status& obj)
{
	Copy((Status*)&obj);
}

Status::~Status()
{}

void Status::Start()
{
	for(int line=0; line<GR_COUNT; line++) if(gr[0][0]==gr[line][0]) Add(line,0,"$");
	Complement();
}

void Status::SetId(int id)
{
	m_id=id; itoa(id,info,10);
}

void Status::Copy(Status*obj)
{
	hash=obj->hash; uint n; strcpy(info,obj->info); m_id=obj->m_id;
	array.clear();
	array.reserve(obj->GetSize());
	for(n=0; n<obj->GetSize(); n++) array.push_back(obj->array[n]);
}

void Status::Dump(FILE *file)
{
	uint line,pos,n,m; char *set;
	fprintf(file,"\n[status %d] [%s]\n",m_id,info);
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos; set=array[n].set.Get();
		fprintf(file,"%c: ",gr[line][0]); if(!pos) fputc('.',file);
		for(m=1; m<strlen(gr[line]); m++) {fputc(gr[line][m],file); if(pos==m) fputc('.',file);}
		fprintf(file,"\t[%s]\n",set);
	}
}

bool Status::Step(char sym)
{
	uint line,pos,n; Status obj;
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		if(gr[line][pos+1]==sym) obj.Add(line,pos+1,array[n].set.Get());
	}
	Copy(&obj);
	Complement();
	return !array.empty();
}


bool Status::Compare(Status *obj)
{
	if(hash!=obj->hash || GetSize()!=obj->GetSize()) return false;
	for(uint n=0; n<GetSize(); n++) if(!array[n].Compare(&obj->array[n])) return false;
	return true;
}


bool Status::CompareKernel(Status *obj)
{
	if(hash_kr!=obj->hash_kr || GetSize()!=obj->GetSize()) return false;
	for(uint n=0; n<GetSize(); n++) {
		if(array[n].line!=obj->array[n].line || array[n].pos!=obj->array[n].pos) return false;
	}
	return true;
}


bool Status::Merge(Status *obj)
{
	uint n;
	strcat(info,","); strcat(info,obj->info);
	for(n=0; n<GetSize(); n++) array[n].set.Intersect(obj->array[n].set.Get());
	CalcHash();
	return 0;
}


bool Status::Add(int line,int pos,char *set)
{
	for(uint n=0; n<GetSize(); n++) if(array[n].line==line && array[n].pos==pos) return false;
	Item item(line,pos,set);
	array.push_back(item);
	return true;
}

int Status::GetSize()
{
	return array.size();
}

Item *Status::GetItem(int index)
{
	return &array[index];
}


void Status::Complement()
{
	uint n,m,line,pos; char sym1,sym2; char *set;
//  
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		for(m=0; m<GR_COUNT; m++) if(gr[m][0]==gr[line][pos+1]) Add(m,0,"");
	}
//  
	for(n=0; n<GetSize(); n++) {
		line=array[n].line; pos=array[n].pos;
		sym1=gr[line][pos+1]; sym2=gr[line][pos+2]; if(!sym1) continue;
		if(sym2) set=GetSet(sym2); else set=array[n].set.Get();
		for(m=0; m<GetSize(); m++) {
			if(gr[array[m].line][0]==sym1) array[m].set.Intersect(set);
		}
	}
//   
	CalcHash();
}


void Status::CalcHash()
{
	hash_kr=GetSize();
	for(uint n=0; n<GetSize(); n++) hash+=array[n].set.GetHash(),hash_kr+=array[n].line+array[n].pos;
	hash+=hash_kr;
}


// =====    

std::list<Status>status_array;

//         
int AddStatus(Status* obj)
{
	uint n=0; std::list<Status>::iterator it;
	for(it=status_array.begin(); it!=status_array.end(); n++,it++) if((it)->Compare(obj)) return n;
	obj->SetId(n);status_array.push_back(*obj);
	return n;
}

//   
void DumpStatusList()
{
	std::list<Status>::iterator it;
	FILE *file=fopen(FILENAME_STATUS,"wt");
	for(it=status_array.begin(); it!=status_array.end(); it++) (it)->Dump(file);
	fclose(file);
}




// =====    

class TableItem{
public:
	int status; char sym;
	TableItem();
	TableItem(const TableItem&);
};

TableItem::TableItem()
{}

TableItem::TableItem(const TableItem& item)
{
	status=item.status; sym=item.sym;
}

operator <(const TableItem& item1,const TableItem& item2)
{
	return item1.status==item2.status && item1.sym<item2.sym || item1.status<item2.status;
}

operator ==(const TableItem& item1,const TableItem& item2)
{
	return item1.status==item2.status && item1.sym==item2.sym;
}

// =====   

std::map<TableItem,int>table; // 

void AddTable(TableItem *item,int to) //    
{
	std::map<TableItem,int>::iterator it=table.find(*item);
	if(it!=table.end()) { 
		if( !((it)->second&FLAG_R) && to&FLAG_R) {printf("* colision warning\n"); return;} //       
		printf("# collision error\n\a"); return;
	}
	table.insert(std::make_pair<TableItem,int>(*item,to));
}


bool TableCheckMerge(int n,int m) //      
{
	int i,t; TableItem item; std::map<TableItem,int>::iterator it;
	for(i=0; i<charset.GetSize(); i++) {
		item.sym=charset.Get(i); 
		item.status=n; it=table.find(item); if(it==table.end()) continue;
		t=(it)->second;
		item.status=m; it=table.find(item); if(it==table.end()) continue;
		if(t==n && (it)->second==m) continue;
		if(t!=(it)->second) return true;
	}
	return false;
}


void TableMerge(int to,int from)  //     (+   )
{
	std::map<TableItem,int>table1; //    
	TableItem item; int t;
	std::map<TableItem,int>::iterator it=table.begin();
	while(it!=table.end()) {
		item=(it)->first;
		t=(it)->second;
		if(t==from) t=to; 
		if(item.status==from) item.status=to; //,table1.insert(std::make_pair<TableItem,int>(item,t));
		table1.insert(std::make_pair<TableItem,int>(item,t));
		it++;
	}
	table=table1;
}


void DumpTable() //   
{
	uint m; int r; TableItem item;
	std::list<Status>::iterator it;
	FILE *file=fopen(FILENAME_TABLE,"wt");
	fputc(' ',file); 
	for(m=0; m<charset.GetSize(); m++) fprintf(file,"|%c",charset.Get(m)); fputc('\n',file);
	for(it=status_array.begin(); it!=status_array.end(); it++) {
		fprintf(file,"%d ",(*it).m_id);
		for(m=0; m<charset.GetSize(); m++) {
			item.status=(*it).m_id; item.sym=charset.Get(m);
			std::map<TableItem,int>::iterator it=table.find(item);
			if(it==table.end()) r=-1; else r=(it)->second;
			if(r<0) fprintf(file,"|");
			else if(r==FLAG_ACC) fprintf(file,"|ACC");
			else if(r&FLAG_R) fprintf(file,"|R%d",r^FLAG_R);
			else fprintf(file,"|%d",r);
		}
		fputc('\n',file);
	}
	fclose(file);
}



// =====    
void Work()
{
	std::list<Status>::iterator it;
	Status obj; uint n,m,i,to; TableItem tab_item; Item *item;
	obj.Start();
	AddStatus(&obj);
//  
	for(n=0,it=status_array.begin(); it!=status_array.end(); it++,n++) {
		for(m=0; m<charset.GetSize(); m++) {
			obj.Copy(&(*it));
			if(obj.Step(charset.Get(m))) {
				tab_item.status=n; 
				tab_item.sym=charset.Get(m);
				to=AddStatus(&obj);
				AddTable(&tab_item,to);
			}
		}
	}
//  
	for(it=status_array.begin(); it!=status_array.end(); it++) {
		tab_item.status=(*it).m_id;
		for(m=0; m<charset.GetSize(); m++) {
			obj.Copy(&(*it)); tab_item.sym=charset.Get(m);
			for(i=0; i<obj.GetSize(); i++) {
				item=obj.GetItem(i); 
				if(gr[item->line][item->pos+1]) continue;
				if(!item->set.isIn(tab_item.sym)) continue;
				to=FLAG_R|item->line; 
				if(gr[item->line][0]==gr[0][0] && tab_item.sym=='$') to=FLAG_ACC;
				AddTable(&tab_item,to);
				break;
			}
		}
	}
//   
	int c,f,t;
	std::list<Status>::iterator it1,it2;
	do{ c=0;
		for(it1=status_array.begin(); it1!=status_array.end(); it1++) {
			it2=it1; it2++;
				for(;it2!=status_array.end();) {
					t = (*it1).m_id;
					f = (*it2).m_id;
					if(!(*it1).CompareKernel(&(*it2))) {it2++;continue;}
					if(TableCheckMerge(f,t)) {it2++;continue;}
					(*it1).Merge(&(*it2));
					TableMerge(t,f);
					it2=status_array.erase(it2);
					c++;
			}
		}
		printf("merge: %d\n",c);
	}while(c);
}


// ======  
bool Parse() 
{
	printf("[Parser]\n");
	std::stack<TableItem>parse_stack; //  
	int read_index=0; char sym; int n,m;
	std::map<TableItem,int>::iterator it;
	TableItem sp; sp.status=0; sp.sym=gr[0][0];
	parse_stack.push(sp);
label1:
	sym=test_line[read_index++]; if(!sym) sym='$'; sp.sym=sym;
label2:
	printf("status:%d   sym:%c\n",sp.status,sp.sym);
	it=table.find(sp); if(it==table.end()) return false;
	sp.status=(it)->second;
	if(sp.status==FLAG_ACC) { printf("accept\n"); return true;}
	if(!(sp.status&FLAG_R)) { parse_stack.push(sp); goto label1;}
	n=sp.status^FLAG_R;
	printf("scroll[%d]: %s\n",n,gr[n]);
	for(m=strlen(gr[n])-1; m; m--) {
		sp=parse_stack.top(); parse_stack.pop();
		if(gr[n][m]!=sp.sym) { printf("internal error.\n"); return false;}
	}
	read_index--;
	sp=parse_stack.top(); sp.sym=gr[n][0];
	goto label2;
}


// ============================

void main()
{
	InstallSets();
	Work();
	DumpStatusList();
	DumpTable();
	printf("parse %s..\n",Parse()?"Ok":"error");
	printf("press enter\n");getchar();

}




